# add_alarm_action.py
#
# Copyright 2006-2007 Helsinki Institute for Information Technology
# and the authors.
#
# Authors: Tero Hasu <tero.hasu@hut.fi>
#

# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge,
# publish, distribute, sublicense, and/or sell copies of the Software,
# and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

data = { 'name': u'Add alarm',
         "type": "python",
         'doc': u'Adds an alarm. The alarm time must be provided as input to this action. The ID of the set alarm is produced as output. The alarm text can be configured, or requested interactively from the user.',
	 'parameters': [ ('alarm message', 'text', u'') ],
	 'tags': ['alarm', 'alert', 'time', 'create']
	}

#---

import appuifw
from s4all.composer.runtime import StopFlow
import misoalarm

def run(input, p):
    almtime = input["input"][0]
    if type(almtime) != float:
        raise ValueError, "no alarm time given as input"
    almtext = p["alarm message"]
    if almtext == "":
        almtext = appuifw.query(u"Message", "text")
        if almtext is None:
            raise StopFlow, "no message given"
    alarm_id = misoalarm.add_alarm(almtime, almtext)
    input[0] = alarm_id
    return input
