#
# amazon_s3_action.py
# 
# Copyright 2007 Helsinki Institute for Information Technology (HIIT)
# and the authors.  All rights reserved.
# 
# Authors: Ville Mäntysaari <ville.mantysaari@hiit.fi>
#

# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge,
# publish, distribute, sublicense, and/or sell copies of the Software,
# and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
# BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
# ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

data = { 'name' : u'Amazon S3 Web Service',
         "type": "python",
         'doc' : u'Use Amazon S3 Web Service',
         'parameters' : [ (u'Access Key', 'text', u''),
                          (u'Secret Access Key', 'text', u''),
                          (u'Bucket', 'text', u''),
                          (u'Key', 'text', u''),
                          (u'Method', 'combo', ([u'get', u'put'], 0))
                        ],
         'tags' : ['web service', 'storage', 'amazon'],
	 'input': 'string',
         'output': 'string'
         
    }

#---

def run(input, parameters):

    import S3

    access_key = parameters["Access Key"]
    secret_access_key = parameters["Secret Access Key"]
    bucket = parameters["Bucket"]
    key = parameters["Key"]

    method = parameters["Method"]

    if access_key == '':
        raise TypeError u'No Access Key supplied'
    if secret_access_key == '':
        raise TypeError u'No Secret Access Key Supplied'

    if method == 0:
        result = get(access_key, secret_access_key, bucket, key)
    else:
        result = put(access_key, secret_accesS_key, bucket, key, input)

    input[0] = result

    return input

def get(access_key, secret_access_key, bucket, key):

    conn = S3.AWSAuthConnection(access_key, secret_access_key)

    result = conn.get(bucket, key).object.data

    return input

def put(access_key, secret_access_key, bucket, key, input):

    conn = S3.AWSAuthConnection(access_key, secret_access_key)

    result = conn.put(bucket, key,
                      S3.S3Object(input[0]),
                      { 'Content-Type': 'text/plain'})

    return result

    # gen = S3.QueryStringAuthGenerator(access_key, secret_access_key)
    # gen.set_expires_in(60)
    # result = gen.get(bucket, key) returns an url from which the data can be fetched

    # conn.put(BUCKET_NAME,
    #          KEY_NAME + '-public',
    #          S3.S3Object('this is a publicly readable test'),
    #          { 'x-amz-acl': 'public-read' , 'Content-Type': 'text/plain' }
