#
# capture_image_action.py
# 
# Copyright 2007 Helsinki Institute for Information Technology (HIIT)
# and the authors.  All rights reserved.
# 
# Authors: Ville Mäntysaari <ville.mantysaari@hiit.fi>
#          Pekka Kanerva <kanerva@hiit.fi>

# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge,
# publish, distribute, sublicense, and/or sell copies of the Software,
# and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
# BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
# ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

data = { 'name': u'Capture image',
         "type": "python",
	 'doc':  u"Capture an image with the phone's camera",
         'parameters': [(u'name', 'text', u'Image'),
                        (u'size', 'combo', ([u'640x480', u'160x120'], 0)),
                        (u'mode', 'combo', ([u'auto',u'night'], 0))],
	 'tags': ['camera', 'picture', 'image', 'phone'],
         'input': 'anything',
         'output': 'string'
       }	 

#---

def run(input, parameters):

    try:
        import camera
    except ImportError:
        input[0] = u'No camera module available'

    path_to_image = u'e:\\Images\\'

    index = parameters["size"]
    temp_size = parameters[1][2][0][index]
    _size = tuple(map(lambda x: int(x), temp_size.split('x')))


    mode_index = parameters["mode"]
    mode = parameters[2][2][0][mode_index]

    img = camera.take_photo(size=_size, exposure=mode)

    filename = parameters["name"]
    filename += u'.jpg'
    full_filename = path_to_image + filename

    #print u'img filename: %s' % filename

    img.save(full_filename)

    input[0] = full_filename

    return input
