#
# make_calendar_alarm_action.py
# 
# Copyright 2007 Helsinki Institute for Information Technology (HIIT)
# and the authors.  All rights reserved.
# 
# Authors: Ville Mäntysaari <ville.mantysaari@hiit.fi>
#

# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge,
# publish, distribute, sublicense, and/or sell copies of the Software,
# and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
# BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
# ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

data = { 'name': u'New alarm to calendar',
         'type': 'python',
         'doc': u'Make a new alarm to calendar, input needs to be the date and time as float',
         'parameters': [(u'Description', 'text', u'Meeting') ],
         'tags': ['calendar', 'make appointment', 'todo', 'phone'],
	 'input': 'float',
         'output': 'anything'
        }

#---

import calendar

def run(input, parameters):

    caldb = calendar.open()
    new_entry = caldb.add_appointment()
    
    if type(input[0]) != float:
        raise ValueError("No alarm time given")
    
    time = input[0]
    
    new_entry.set_time(time)
    new_entry.alarm = time
    new_entry.content = parameters["Description"]
    
    new_entry.commit()

    output = u'Success'
    
    input[0] = output
    return input
