#
# match_files_action.py
# 
# Copyright 2007 Helsinki Institute for Information Technology (HIIT)
# and the authors.  All rights reserved.
# 
# Authors: Tero Hasu <tero.hasu@hut.fi>
#          

# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge,
# publish, distribute, sublicense, and/or sell copies of the Software,
# and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
# BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
# ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

data = { 'name': u'Match files',
         "type": "python",
         'doc': u'List the files whose pathnames match a pattern',
	 'parameters': [ ('pattern', 'text', u'') ],
         'tags': ['glob', 'file', 'phone', 'search'],
         'input': 'string',
         'output': 'list'
      }

#---

def run(input, p):
    """
    glob available from
    http://people.csail.mit.edu/kapu/symbian/python.html
    """

    import appuifw
    import glob

    pat = p["pattern"]
    if pat == u"":
        if input:
            pat = unicode(input[0])

    while pat == u"":
        pat = appuifw.query(u'Pattern:', 'text')

    #print "pattern is", pat
    input = glob.glob(pat)

    return input

