#
# send_sms_action.py
# 
# Copyright 2007 Helsinki Institute for Information Technology (HIIT)
# and the authors.  All rights reserved.
# 
# Authors: Ville Mäntysaari <ville.mantysaari@hiit.fi>
#          Pekka Kanerva <kanerva@hiit.fi>

# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge,
# publish, distribute, sublicense, and/or sell copies of the Software,
# and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
# BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
# ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

data = { 'name': u'Send SMS',
         "type": "python",
	 'doc':  u'Sends an SMS. For both mobile number and message, there are three configuration options, "configure", "ask user", and "get as input". In configure option, a default value can be set in configuration. In "ask user", the value is asked at run time. The input choice reads the value from the action input.',
         'paramtype': 'tuples',
         'parameters': [ (u'number','combo', ([u'configure',u'ask user',u'get as input'], 0)),
                         (u'value', 'text',u''),
                         (u'message', 'combo', ([u'configure', u'ask user', u'get as input'], 0)),
                         (u'value', 'text', u'') ],
         'tags': ['sms', 'text message', 'phone'],
         'input': 'string',
         'output': 'anything'
       }	 

#---

def _get_number(input, parameters):
    selected_index = parameters[0][2][1]
    selection = parameters[0][2][0][selected_index]

    if selection == u'configure':
        return parameters[1][2]
    elif selection == u'ask user':
        import appuifw
        number = appuifw.query(u'number:', 'text', u'')
        return number
    elif selection == u'get as input':
        return input[0]
        

def _get_message(input, parameters):
    selected_index = parameters[2][2][1]
    selection = parameters[2][2][0][selected_index]

    if selection == u'configure':
        return parameters[3][2]
    elif selection == u'ask user':
        import appuifw
        message = appuifw.query(u'message:', 'text', u'')
        return message
    elif selection == u'get as input':
        return input[0]
    

def run(input, parameters):

    import appuifw, messaging

    number = _get_number(input, parameters)
    message = _get_message(input, parameters)

    messaging.sms_send(number, message)

    input[0] = u'Done'
    
    return input
