#
# yahoo_search_images_action.py
# 
# Copyright 2007 Helsinki Institute for Information Technology (HIIT)
# and the authors.  All rights reserved.
# 
# Authors: Ville Mäntysaari <ville.mantysaari@hiit.fi>
#          Pekka Kanerva <kanerva@hiit.fi>

# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge,
# publish, distribute, sublicense, and/or sell copies of the Software,
# and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
# BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
# ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

data = { "name": u"Yahoo Image Search Service",
         "type": "python",
	 "doc": u"This action uses Yahoo Image Search Service to search for images with a search string. The search criteria is configured as a parameter. User can also define the number of search results. The action returns the URL of the image which user selects.",
         'paramtype': 'tuples',
	 "parameters": [(u'criteria', 'text', u'Madonna'),
                        (u'results', 'text', u'2')],
         "tags": ['search', 'image', 'web service'],
         'input': 'string',
         'output': 'list'
       }

#---

def run(input, parameters):

    import urllib, simplejson, appuifw

    result = urllib.urlopen("http://api.search.yahoo.com/ImageSearchService/V1/imageSearch?appid=noeivoiollaapplikaatio&query="+parameters[0][2]+"&results="+parameters[1][2]+"&output=json")

    urls = []
    names = []
    
    for line in result.readlines():
        json_result = simplejson.loads(line)

    for result in json_result['ResultSet']['Result']:
        urls.append(result['Url'])
        names.append(result['Title'])

    selected = appuifw.popup_menu(names, u"Search results")

    input = [urls[selected]]

    return input


