#
# yahoo_traffic_rest_action.py
# 
# Copyright 2007 Helsinki Institute for Information Technology (HIIT)
# and the authors.  All rights reserved.
# 
# Authors: Ville Mäntysaari <ville.mantysaari@hiit.fi>
#          Pekka Kanerva <kanerva@hiit.fi>

# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge,
# publish, distribute, sublicense, and/or sell copies of the Software,
# and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
# BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
# ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

data = { "name": u"Yahoo Traffic Service",
         "type": "python",
	 "doc": u"This action uses Yahoo Traffic Web Service to report the user of traffic problems in the area user wants to see the info.",
         'paramtype': 'tuples',
	 "parameters": [(u'street', 'combo',([u'configure', u'ask user', u'get as input'], 0)),
                  (u'value', 'text', u'701 First Ave'),
                  (u'city', 'combo', ([u'configure', u'ask user', u'get as input'], 0)),
                  (u'value', 'text', u'Sunnyvale'),
                  (u'state','combo', ([u'configure', u'ask user', u'get as input'], 0)),
                  (u'value','text', u'CA')],
         "tags": ['web service', 'traffic', 'usa'],
         'input': 'string',
         'output': 'string'
       }

#---

def run(input = data['input'], parameters = data['parameters']):

    import urllib, simplejson, time

    street = _get_street(parameters)
    city = _get_city(parameters)
    state = _get_state(parameters)
    
    result = urllib.urlopen("http://api.local.yahoo.com/MapsService/V1/trafficData?appid=noeivoiollaapplikaatio\&street=" + street.replace(' ', '+') + "\&city="+ city.replace(' ', '+') + "\&state="+ state + '\&output=json')
    res = ''
    for line in result.readlines():
        json_result = simplejson.loads(line)
    for result in json_result['ResultSet']['Result']:
        res += u'Reportdate: ' + time.ctime(result['ReportDate']) + ' '
        res += u'Direction : ' + result['Direction'] + ' '
        res += u'Type: ' + result['type'] + ' '
        res += u'Severity: ' + str(result['Severity']) + ' '
        res += u'Description: \n' + result['Description'] + ' '
        res += u'\n'

    input[0] = res

    return input


def _get_street(parameters):

    selected_index = parameters[0][2][1]
    selection = parameters[0][2][0][selected_index]

    if selection == u'configure':
        return parameters[1][2]
    elif selection == u'ask user':
        import appuifw
        street = appuifw.query(u'street:', 'text', u'')
        return street
    elif selection == u'get as input':
        return input[0]


def _get_city(parameters):

    selected_index = parameters[2][2][1]
    selection = parameters[2][2][0][selected_index]

    if selection == u'configure':
        return parameters[3][2]
    elif selection == u'ask user':
        import appuifw
        city = appuifw.query(u'city:', 'text', u'')
        return city
    elif selection == u'get as input':
        return input[0]

def _get_state(parameters):

    selected_index = parameters[4][2][1]
    selection = parameters[4][2][0][selected_index]

    if selection == u'configure':
        return parameters[5][2]
    elif selection == u'ask user':
        import appuifw
        state = appuifw.query(u'state:', 'text', u'')
        return state
    elif selection == u'get as input':
        return input[0]
