#
# yubnub_action.py
# 
# Copyright 2007 Helsinki Institute for Information Technology (HIIT)
# and the authors.  All rights reserved.
# 
# Authors: Tero Hasu <tero.hasu@hut.fi>
#

# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge,
# publish, distribute, sublicense, and/or sell copies of the Software,
# and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
# BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
# ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

data = { 'name': u'YubNub',
         "type": "python",
	 'doc':  u'Runs a YubNub command, and returns the output.',
         'parameters': [('command', 'text', u'gmobile {url xe -amount 1 -from EUR -to USD}')],
         'tags': ['yubnub', 'web service'],
         'input': 'string',
         'output': 'string'
       }	 

#---

import urllib
import appuifw

def run(input, p):

    command = p["command"]
    if command == u"":
        if input:
            command = unicode(input[0])

    while command == u"":
        command = appuifw.query(u'Command:', 'text')

    yub_url = 'http://www.yubnub.org/parser/parse?'
    args = urllib.urlencode({"command": command})
    url = yub_url + args

    res = urllib.urlopen(url)
    try:
        input[0] = res.read()
        return input
    finally:
        res.close()
