# runtime.py
#
# Copyright 2007 Helsinki Institute for Information Technology
# and the authors.
#
# Authors: Tero Hasu <tero.hasu@hut.fi>
#

# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge,
# publish, distribute, sublicense, and/or sell copies of the Software,
# and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

# Runtime support for workflow and action execution.
# This API may be used within actions, too.

class StopFlow(Exception):
    def __init__(self, value):
        """
        "value" specifies the result (or return value) of the entire
        flow.
        """
        self.value = value

    def __str__(self):
        return repr(self.value)

class EndLoop(Exception):
   def __init__(self, value):
	self.value = value

   def __str__(self):
       return repr(self.value)

list_type = type([])

def ensure_list(list):
    if type(list) is list_type:
        return list
    return [list]
