# gen_actions_pkg.py
#
# Copyright 2006-2007 Helsinki Institute for Information Technology
# and the authors.
#
# Authors: Pekka Kanerva <kanerva@hiit.fi>
#

# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge,
# publish, distribute, sublicense, and/or sell copies of the Software,
# and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

#!/usr/bin/env python

from os import listdir, stat
from stat import *
import time

# ATTN: upper/lowercase letters _DO_ make difference in the hex codes
# in HEADER variable

def get_actions():
    return  [ a for a in listdir(".")
              if a.endswith(".py") and
              not a.startswith("__") and
              not a.startswith("#") and
              not a.startswith(".#")]


"""
def write_status_file(actions):

    status_file = open("__status__.txt", 'w+')
    
    for a in actions:
        last_modified = stat("./" + a)[ST_MTIME]
        #print last_modified
        status_file.write(a + ";" + \
                          time.strftime("%d-%b-%Y %H:%M",
                                        time.gmtime(last_modified)) + \
                          "\n")

    status_file.close()
"""


def write_pkg_file(actions):

    HEADER = "&EN\n" + \
             "#{\"S4ALL Composer Actions\"}, (0x00611601), 0, 20, 0\n" + \
             "(0x101F7960), 0, 0, 0, {\"Series60ProductID\"}\n"
    
    
    actions.append("__init__.py")
#    actions.append("__status__.txt")
    
    pkg_file = open("composer_actions.pkg",'w+')
    
    pkg_file.write(HEADER)
    
    for action in actions:
        line = '\"' + action + '\"'
        line += '-\"!:\\System\\libs\\s4all\\actions\\' + action + '\"\n'
        pkg_file.write(line)

    pkg_file.close()


if __name__ == "__main__":
    actions = get_actions()
#    write_status_file(actions)
    write_pkg_file(actions)
